//  游戏引擎
var engine = null;

var Engine = cc.Class.extend({
    // 是否初始化
    isInit: null,
    // 游戏时间单例
    gameTime:null,
    // 数据单例
    gameData:null,
    // 声音单例
    gameSound:null,
    // 缓冲单例
    gamePool:null,
    // 元素管理类单例
    gameElementManage:null,
    // 技能管理单例
    gameSkillManage:null,
    // 更新心跳
    gameUpdate:null,
    // 事件管理机制
    gameEvent:null,
    //cocosstudio
    gameCocosStudio:null,
    // 层的管理
    gameLayer:null,

    ctor: function ()
    {
        this.isInit = false;
    },

    initialize: function()
    {
        if (this.isInit == true)
        {
            return;
        }

        printLog("游戏引擎" + gameEngineVersion);

        cc.view.resizeWithBrowserSize(true);
        cc.view.adjustViewPort(true);
        cc.view.setDesignResolutionSize(gameWidth, gameHigh, gameLayout);
        cc.view.enableRetina(true);

        this.isInit = true;

        this.gameTime = new GameTime();
        this.gameTime.initialize();

        this.gameData = new GameData();
        this.gameData.initialize();

        this.gameSound = new GameSound();
        this.gameSound.initialize();

        this.gamePool = new GamePool();
        this.gamePool.initialize();

        this.gameElementManage = new GameElementManage()
        this.gameElementManage.initialize();

        this.gameSkillManage = new GameSkillManage()
        this.gameSkillManage.initialize();

        this.gameUpdate = new GameUpdate();
        this.gameUpdate.initialize();

        this.gameEvent = new GameEvent();
        this.gameEvent.initialize();

        this.gameLayer = new GameLayer();
        this.gameLayer.initialize();

        this.gameCocosStudio = new GameCocosStudio();
        this.gameCocosStudio.initialize();
    },

    engineuUpdate:function(data)
    {
        engine.gameTime.updateTime(data);
        engine.gameUpdate.update();
    }
})

var initEngine = function ()
{
    if(engine == null)
    {
        engine = new Engine();
        engine.initialize();
    }
}