/**
 * Created by Administrator on 2016/9/12.
 */

// 创建遮罩层
var createMaskLayer = function(ui, bg)
{
    var maskLayer = new cc.Layer();
    if(bg != null)
    {
        maskLayer.addChild(bg);
    }
    else
    {
        var draw = new cc.DrawNode();
        draw.drawRect(cc.p(0, 0), cc.p(gameWidth, gameHigh), cc.color(0, 0, 0, 180), 0, cc.color(0, 0, 0, 180));
        var sprite = new cc.Sprite();
        sprite.addChild(draw);
        maskLayer.addChild(sprite);
    }
    ui.maskLayer = maskLayer;
    ui.addChild(maskLayer, -1);
    engine.gameEvent.createMouseDown(maskLayer, function(){}, null, cc.rect(0, 0, gameWidth, gameHigh));
    return ui;
}

// 创建遮罩层根据矩形形状
var createMaskRectLayer = function(ui, rectList, transparentRectList)
{
    if(transparentRectList == null)
    {
        transparentRectList = [];
    }

    var maskLayer = new cc.Layer();
    for(var n = 0; n < rectList.length; n++)
    {
        var rect = rectList[n];
        var draw = new cc.DrawNode();
        draw.drawRect(cc.p(0, 0), cc.p(rect.width, rect.height), cc.color(0, 0, 0,90), 0, cc.color(0, 0, 0, 0));
        var sprite = new cc.Sprite();
        sprite.addChild(draw);
        sprite.x = rect.x;
        sprite.y = rect.y;
        maskLayer.addChild(sprite);
    }

    for(var n = 0; n < transparentRectList.length; n++)
    {
        var rect = transparentRectList[n];
        var draw = new cc.DrawNode();
        draw.drawRect(cc.p(0, 0), cc.p(rect.width, rect.height), cc.color(255, 0, 0,90), 0, cc.color(0, 0, 0, 0));
        var sprite = new cc.Sprite();
        sprite.addChild(draw);
        sprite.x = rect.x;
        sprite.y = rect.y;
        maskLayer.addChild(sprite);
    }

    maskLayer.checkClick = function(touch, event)
    {
        // 获取范围判断点击事件是否有效
        var target = event.getCurrentTarget();
        var pos = target.convertToNodeSpace(touch.getLocation());
        for(var n = 0; n < rectList.length; n++)
        {
            var rect = rectList[n];
            if(cc.rectContainsPoint(rect, pos))
            {
                return true;
            }
        }
        return false;
    }
    engine.gameEvent.createMouseDown(maskLayer, function(){}, null);

    ui.maskLayer = maskLayer;
    ui.addChild(maskLayer, -1);
    return ui;
}

var createPageLayer = function(data)
{
    var pageLayer = new GamePageLayer();
    pageLayer.addChild(data.ui);
    pageLayer.initialize(data);

    return pageLayer;
}

// 横向翻页
var landscapePage = 1;
// 纵向翻页
var portaitPage = 2;

// 翻页容器
var GamePageLayer = cc.Layer.extend({

    // 点下的点
    mouseDownPoint:null,
    // 是否移动了
    isMove:null,
    // 当前页数
    pageIndex:null,
    // 页数的宽
    pageWidth:null,
    // 总页数
    pageMax:null,
    // 翻页方式
    turnPageState:null,
    // 翻页显示图标
    pageIconList:null,
    // 每页数据容器
    pageList:null,
    // 翻页效果 1 是手动 鼠标翻页  2 缩放翻页
    pageEffect:null,
    // 每页容器个数
    pageItemCount:null,
    // 是否在播放效果
    isPlayPageEffect:null,
    // 翻页效果
    pageEffectFun:null,
    // 动态页面
    setPageInfo:null,

    ctor: function()
    {
        this.isMove = false;
        this.pageIndex = 0;
        this.isPlayPageEffect = false;
        this._super();
    },

    initialize: function(data)
    {
        this.pageMax = data.pageMax;
        this.pageWidth = data.pageWidth;
        this.turnPageState = data.turnPageState;
        this.pageIconList = data.pageIconList;
        this.pageList = data.pageList;
        this.pageEffect = data.pageEffect;
        this.pageComplete = data.pageComplete;
        this.pageItemCount = data.pageItemCount;
        this.pageEffectFun = data.pageEffectFun;
        this.setPageInfo = data.setPageInfo;
        // 翻页监听事件 是否以鼠标移动作为翻页控制
        switch(this.pageEffect)
        {
            case 1:
                engine.gameEvent.createMouseDown(this, this.mouseDown, null, data.clickRect);
                engine.gameEvent.createMouseMove(this, this.mouseMove, null, data.clickRect);
                engine.gameEvent.createMouseUp(this, this.mouseUp, null, data.clickRect);
                break;
            case 2:
                break;
        }

        this.setPageIcons();
        this.setPageIndex(0);
    },

    // 隐藏没有选中的页
    hiddenNoCheckedPage:function()
    {
        for(var n = 0; n < this.pageList.length; n++)
        {
            if(n >= this.pageIndex * this.pageItemCount && n < (this.pageIndex + 1) * this.pageItemCount)
            {
                this.pageList[n].setVisible(true);
            }
            else
            {
                this.pageList[n].setVisible(false);
            }
        }
    },

    mouseUp:function(touch, event)
    {
        this.isMove = false;
        this.mouseDownPoint = null;
    },

    mouseDown:function(touch, event)
    {
        this.isMove = false;
        // 获取范围判断点击事件是否有效
        var target = event.getCurrentTarget();
        var rect = target.getClickRect();
        var pos = target.convertToNodeSpace(touch.getLocation());
        this.mouseDownPoint = pos;
    },

    mouseMove:function(touch, event)
    {
        // 获取范围判断点击事件是否有效
        var target = event.getCurrentTarget();
        var rect = target.getClickRect();
        var pos = target.convertToNodeSpace(touch.getLocation());

        if(this.mouseDownPoint != null)
        {
            var dis = cc.pDistance(this.mouseDownPoint, pos);
            // 判断是否滑动了
            if(dis >= 30)
            {
                this.isMove = true;

                switch(this.turnPageState)
                {
                    // 横向翻页
                    case landscapePage:
                        // 判断向左还是向右滑动了
                        if(pos.x - this.mouseDownPoint.x >= 0)
                        {
                            this.lastPage();
                            this.mouseDownPoint = null;
                        }
                        else
                        {
                            this.nextPage();
                            this.mouseDownPoint = null;
                        }
                        break;
                    // 纵向翻页
                    case portaitPage:
                        // 判断向上还是向下滑动了
                        if(pos.y - this.mouseDownPoint.y >= 0)
                        {
                            this.lastPage();
                            this.mouseDownPoint = null;
                        }
                        else
                        {
                            this.nextPage();
                            this.mouseDownPoint = null;
                        }
                        break;
                }

            }
        }
    },

    // 下一页
    nextPage:function()
    {
        if(this.isPlayPageEffect == true)
        {
            return;
        }

        if(this.pageIndex + 1 < this.pageMax)
        {
            this.pageIndex++;
            this.setPageIndex(this.pageIndex);
        }
    },

    // 上一页
    lastPage:function()
    {
        if(this.isPlayPageEffect == true)
        {
            return;
        }

        if (this.pageIndex - 1 >= 0)
        {
            this.pageIndex--;
            this.setPageIndex(this.pageIndex);
        }
    },

    setPageIndex:function(pageIndex)
    {
        switch(this.pageEffect)
        {
            case 1:
                this.stopAllActions();
                this.pageIndex = pageIndex;
                var move = cc.moveTo(0.5, cc.p(-this.pageIndex * this.pageWidth, this.y));
                this.runAction(move);
                this.setPageIcons();
                if(this.setPageInfo != null)
                {
                    this.setPageInfo(this.pageIndex);
                }
                break;
            case 2:
                this.pageIndex = pageIndex;
                this.x = -this.pageIndex * this.pageWidth;
                this.y = this.y;
                // 获取当前页面的元素
                var arr = [];
                for(var n = 0; n < this.pageList.length; n++)
                {
                    if(n >= this.pageIndex * this.pageItemCount && n < (this.pageIndex + 1) * this.pageItemCount)
                    {
                        arr.push(this.pageList[n]);
                    }
                }
                this.isPlayPageEffect = true;
                if(this.pageEffectFun != null)
                {
                    this.pageEffectFun(arr);
                }
                this.setPageIcons();
                if(this.setPageInfo != null)
                {
                    this.setPageInfo(this.pageIndex);
                }
                break;
        }
    },

    // 设置pageicon是否显示
    setPageIcons:function()
    {
        if(this.pageIconList.length <= 0)
        {
            return;
        }
        for(var n = 0; n < this.pageIconList.length; n++)
        {
            this.pageIconList[n].setVisible(false);
        }
        this.pageIconList[this.pageIndex].setVisible(true);
    }
})

var GameLayer = cc.Class.extend({

    // 是否初始化
    isInit: null,
    createMaskLayer:null,
    createPageLayer:null,

    ctor: function()
    {
        this.isInit = false;
    },

    initialize: function ()
    {
        if (this.isInit == true)
        {
            return;
        }
        this.isInit = true;

        this.createMaskLayer = createMaskLayer;
        this.createPageLayer = createPageLayer;
    }
})