/**
 * Created by Administrator on 2016/9/12.
 */
/**
 * Created by Administrator on 2016/2/26.
 */
var cocosUIAction = new Object();

var GameCocosStudio = cc.Class.extend({

    // 是否初始化
    isInit: null,
    loadCSS:null,

    ctor: function ()
    {
        this.isInit = false;
    },

    initialize: function ()
    {
        if (this.isInit == true)
        {
            return;
        }
        this.isInit = true;

        this.loadCSS = loadCSS;
    },

    // 只有文字发生改变才可以更改文本
    setChangeString:function(ui)
    {
        ui.txtValue = "";
        ui.setString = function(value)
        {
            if(ui.txtValue != value)
            {
                ui.txtValue = value;
                ui.setString(value);
            }
        }
    }
})

// 鼠标移动事件
var createMouseMove = function(ui, fun, typeList, clickRect)
{
    ui.mouseDownTypeList = typeList;
    // 是否是CCS
    if(ui.addTouchEventListener != null)
    {
        createCCSTouchEventListener(ui);
    }
    else
    {
        createTouchEventListener(ui, clickRect);
    }

    // 鼠标移动事件
    ui.mouseMovefun = fun;
    ui.mouseMove = function(touch, event)
    {
        if(ui.mouseMovefun != null)
        {
            ui.mouseMovefun(touch, event);
        }
    };
}

// 创建按下事件
var createMouseDown = function(ui, fun, typeList, clickRect)
{
    ui.mouseDownTypeList = typeList;
    // 是否是CCS
    if(ui.addTouchEventListener != null)
    {
        createCCSTouchEventListener(ui);
    }
    else
    {
        createTouchEventListener(ui, clickRect);
    }

    // 鼠标按下事件
    ui.mouseDownfun = fun;
    ui.mouseDown = function(touch, event)
    {
        if(ui.mouseDownTypeList != null &&  ui.mouseDownTypeList.indexOf(buttonScalingType) >= 0)
        {
            if(ui.bottonSound == null)
            {
                // engine.gameSound.playEffect(defaultBottonSound);
            }

            ui.setScale(0.9);
        }

        if(ui.mouseDownfun != null)
        {
            ui.mouseDownfun(touch, event);
        }
    };

    if(ui.mouseUp == null)
    {
        ui.mouseUp = function(touch, event)
        {
            if(ui.mouseDownTypeList != null &&  ui.mouseDownTypeList.indexOf(buttonScalingType) >= 0)
            {
                ui.setScale(1);
            }
        }
    }
}

// 鼠标弹起事件
var createMouseUp = function(ui, fun, typeList, clickRect)
{
    if(typeList != null)
    {
        ui.mouseDownTypeList = typeList;
    }
    // 是否是CCS
    if(ui.addTouchEventListener != null)
    {
        createCCSTouchEventListener(ui);
    }
    else
    {
        createTouchEventListener(ui, clickRect);
    }

    // 鼠标移动事件
    ui.mouseUpfun = fun;
    ui.mouseUp = function(touch, event)
    {
        if(ui.mouseDownTypeList != null &&  ui.mouseDownTypeList.indexOf(buttonScalingType) >= 0)
        {
            ui.setScale(1);
        }

        if(ui.checkClick(touch, event) == false)
        {
            return false;
        }

        if(ui.mouseUpfun != null)
        {
            ui.mouseUpfun(touch, event);
        }
    };

    if(ui.mouseDown == null)
    {
        ui.mouseDown = function(touch, event)
        {
            if(ui.mouseDownTypeList != null &&  ui.mouseDownTypeList.indexOf(buttonScalingType) >= 0)
            {
                if(ui.bottonSound == null)
                {
                    // engine.gameSound.playEffect(defaultBottonSound);
                }

                ui.setScale(0.9);
            }
        }
    }
}

// 创建UI事件监听
var createTouchEventListener = function(ui, clickRect)
{
    // 检验点击事件
    if(ui.checkClick == null)
    {
        // 是否需要设置显示的点击
        if(clickRect != null)
        {
            ui.getClickRect = function()
            {
                return clickRect;
            }
        }
        else
        {
            // 如果是节点则需要额外处理
            if(ui.constructor == cc.Node)
            {
                var count = 0;
                var size = null;
                size = findClickSize(ui,size);
                if(size != null)
                {
                    ui.getClickRect = function()
                    {
                        var rect = cc.rect(-size.width * 1/2, -size.height * 1/2, size.width, size.height);
                        return rect;
                    }
                }
                else
                {
                    ui.getClickRect = function()
                    {
                        var size = ui.getContentSize();
                        var rect = cc.rect(cc.rect(0, 0, size.width, size.height));
                        return rect;
                    }
                }
            }
            else
            {
                ui.getClickRect = function()
                {
                    var size = ui.getContentSize();
                    var rect = cc.rect(cc.rect(0, 0, size.width, size.height));
                    return rect;
                }
            }
        }

        ui.checkClick = function(touch, event)
        {
            // 获取范围判断点击事件是否有效
            var target = event.getCurrentTarget();
            var rect = target.getClickRect();
            var pos = target.convertToNodeSpace(touch.getLocation());

            if(cc.rectContainsPoint(rect, pos))
            {
                return true;
            }
            return false;
        }
    }

    ui.eventMouseDown = function(touch, event)
    {
        if(ui.checkClick(touch, event) == false || !ui.isVisible())
        {
            return false;
        }

        if(ui.mouseDown != null)
        {
            ui.mouseDown(touch, event);
        }

        return true;
    }

    ui.eventMouseMove = function(touch, event)
    {
        if(ui.mouseMove != null && ui.isVisible())
        {
            ui.mouseMove(touch, event);
        }
    }
    ui.eventMouseUp = function(touch, event)
    {
        if(ui.mouseUp != null && ui.isVisible() && ui.getParent().isVisible())
        {
            ui.mouseUp(touch, event);
        }
    }

    var isSwallowTouches = true;
    if(ui.isSwallowTouches != null)
    {
        isSwallowTouches = ui.swallowTouches;
    }

    ui.uiListener =
    cc.eventManager.addListener({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: isSwallowTouches,
        onTouchBegan: ui.eventMouseDown,
        onTouchMoved: ui.eventMouseMove,
        onTouchEnded: ui.eventMouseUp,
        onTouchCancelled: null
    }, ui);
}

// 创建UI事件监听 cocosstudio 事件监听
var createCCSTouchEventListener = function(ui)
{
    if(ui.touchEvent != null)
    {
        return;
    }
    ui.touchEvent = function(sender, type)
    {
        switch (type)
        {
            case ccui.Widget.TOUCH_BEGAN:
                if (ui.mouseDown != null)
                {
                    ui.mouseDown();
                }
                break;
            case ccui.Widget.TOUCH_MOVED:
                if (ui.mouseMove != null)
                {
                    ui.mouseMove();
                }
                break;
            case ccui.Widget.TOUCH_ENDED:
                if (ui.mouseUp != null)
                {
                    ui.mouseUp();
                }
                break;
            case ccui.Widget.TOUCH_CANCELED:
                break;
            default:
                break;
        }
    }

    ui.addTouchEventListener(ui.touchEvent, ui);
}

// 获取点击的点范围
var findClickSize = function(ui, clickSize)
{
    var size = ui.getContentSize();
    if(size.width != 0 && size.height != 0)
    {
        clickSize = size;
    }
    else
    {
        var arr = ui.getChildren();
        for(var n = 0;n < arr.length; n++)
        {
            clickSize = findClickSize(arr[n], clickSize);
        }
    }
    return clickSize;
}

// 封装精灵事件
var setCCSSprite = function(ui, spriteNodePaths)
{
    var uiName = ui.getName();
    var mcaction = (cocosUIAction[spriteNodePaths[uiName]]).clone();
    ui.runAction(mcaction);
    ui.gotoStop = function(frameIndex)
    {
        mcaction.gotoFrameAndPlay(frameIndex, frameIndex, false);
    }
}

// 设置精灵多语言事件
var setCCSSpriteText = function(ui, spriteNodePaths)
{
    var uiName = ui.getName();
    var mcaction = (cocosUIAction[spriteNodePaths[uiName]]).clone();
    ui.runAction(mcaction);
    ui.gotoStop = function(frameIndex)
    {
        mcaction.gotoFrameAndPlay(frameIndex, frameIndex, false);
    }

    // 根据多语言设置动画
    ui.gotoStop(languageIndex);
}

// 设置多语言
var setCCSTxtLanguage = function(ui)
{
    var uiName = ui.getName();
    var arr = uiName.split("_");

    if(arr.length > 0)
    {
        ui.setString(engine.gameData.getLanguageByKey(arr[1]));
    }
    else
    {
        printLog("你所配置的文本没有指定多语言配置文件所需要的键值!!!")
    }
}

// 设置所有UI
var setCCSAllUI = function(ui, spriteNodePaths)
{
    var arrayRootChildren = ui.getChildren();
    var length = arrayRootChildren.length;
    // 文字自动多语言
    var uiName = ui.getName();

    if(ui.parent != null)
    {
        if(ui.parent[uiName] == null)
        {
            ui.parent[uiName] = ui;
        }
        else
        {
            printLog("你在UI里面起的名字是关键字或重复！请检查CCS");
        }
    }

    ui.getChildByName = function(uiName)
    {
        var node = null;
        node = findChildByName(ui, uiName, node);
        return node;
    }

    // 文字多语言
    if(uiName.indexOf("txt_") >= 0)
    {
        var arr = uiName.split("_");
        setCCSTxtLanguage(ui, arr[1]);
    }

    // 设置精灵
    if(uiName.indexOf("sp_") >= 0)
    {
        setCCSSprite(ui, spriteNodePaths);
    }

    // 设置精灵多语言
    if(uiName.indexOf("spt_") >= 0)
    {
        setCCSSpriteText(ui, spriteNodePaths);
    }

    // 设置声音按钮
    if(uiName.indexOf("_sound") >= 0)
    {
        setCCSSound(ui, spriteNodePaths);
    }

    // 设置默认字体
    if(uiName.indexOf("_df") >= 0)
    {
        ui.setFontName(defaultTxt);
    }


    // 设置所有UI
    for (var i = 0; i < length; i++)
    {
        setCCSAllUI(arrayRootChildren[i], spriteNodePaths);
    }
}

// 读取CCS
var loadCSS = function(url, isLoadJS)
{
    if(isLoadJS == null)
    {
        isLoadJS = true;
    }
    var mc = ccs.load(url).node;
    // 精灵控件绑定文件路径
    var spriteNodePaths = new Object();
    if(isLoadJS == true)
    {
        loadAction(url);
        var res = cc.loader.getRes(url);
        var nodes = res.Content.Content.ObjectData.Children;
        spriteNodePaths = getChildrenNodePath(nodes, spriteNodePaths);
    }

    setCCSAllUI(mc, spriteNodePaths);
    return mc;
}

// 递归读取json里面的action
var loadAction = function(url)
{
    if(cocosUIAction != null)
    {
        var mc = ccs.load(url).node;
        // 保存json action
        cocosUIAction[url] = ccs.load(url).action;
        var res = cc.loader.getRes(url);
        var nodeJson =  res.Content.Content.UsedResources;

        // 获取 json 节点数据
        for (var i = 0; i < nodeJson.length; i++)
        {
            if (nodeJson[i].indexOf(".json") > 0)
            {
                loadAction("res/" + nodeJson[i]);
            }
        }
    }
}

function getChildrenNodePath(nodes, spriteNodePaths)
{
    for(var n = 0;n < nodes.length; n++)
    {
        var name = nodes[n].Name;
        if(name.indexOf("sp_") >= 0 || name.indexOf("spt_") >= 0)
        {
            spriteNodePaths[name] = "res/" + nodes[n].FileData.Path;
        }
        if(nodes[n].Children != null)
        {
            spriteNodePaths = getChildrenNodePath(nodes[n].Children, spriteNodePaths);
        }

        if(name.indexOf("sp_") < 0 && name.indexOf("spt_") < 0)
        {
            if(nodes[n].FileData != null && nodes[n].FileData.Path != null && nodes[n].FileData.Path.indexOf(".json") >= 0)
            {
                var res = cc.loader.getRes("res/" + nodes[n].FileData.Path);
                var nodes = res.Content.Content.ObjectData.Children;
                spriteNodePaths = getChildrenNodePath(nodes, spriteNodePaths);
            }
        }
    }
    return spriteNodePaths;
}

// 找到其子子孙孙有这个名字的元件
var findChildByName = function(ui, uiName, node)
{
    var childrens = ui.getChildren();
    for(var n = 0; n < childrens.length; n++)
    {
        if(uiName == childrens[n].getName())
        {
            node = childrens[n];
        }
        else
        {
            node = findChildByName(childrens[n], uiName, node);

        }
    }

    return node;
}