// 静态数据
var dataPathDic = new Object();

var GameData = cc.Class.extend({

    // 是否初始化
    isInit: null,
    // 数据字典集合
    dataDic:null,
    // 是否初始话数据了
    isCreateJsonData:null,
    // 多语言数据集合
    languageDic:null,
    // 帧动画数据地址
    animationDic:null,

    ctor: function ()
    {
        this.isInit = false;
        this.isCreateJsonData = false;
        this.dataDic = new Object();
    },

    addDataDic:function(key, dic)
    {
        this.dataDic[key] = dic;
    },

    initialize: function ()
    {
        if (this.isInit == true)
        {
            return;
        }
        this.isInit = true;
    },

    // 创建JSON数据文件
    createJsonData : function()
    {
        if(this.isCreateJsonData)
        {
            return;
        }

        this.isCreateJsonData = true;

        // 填充数据字典
        for(var key in dataPathDic)
        {
            this.dataDic[key] = this.analysisJsonData(cc.loader.getRes(dataPathDic[key]), key);
        }

        // 填充多语言
        this.languageDic = new Object();
        this.languageDic = this.analysisJsonData(cc.loader.getRes(languagePath), languagePath);
    },

    // 获取文字信息 根据键值
    getLanguageByKey:function(key)
    {
        if(this.languageDic[key] != null)
        {
            return this.languageDic[key].content;
        }

        printLog("配置的多语言" + key +"缺少对应的键值");

        return "";
    },

    // 解析json数据
    analysisJsonData : function(jsondata, url)
    {
        if(jsondata == null)
        {
            printLog("配置的"+ url +"JSON文件缺失");
            return;
        }
        var obj = new Object();
        // execel 第一行显示的是字段名字
        for(var n = 1; n < jsondata.length; n++)
        {
            var item = new Object();
            for(var m = 0; m < jsondata[n].length; m++)
            {
                if(jsondata[n][m] != "null")
                {
                    item[jsondata[0][m]] = jsondata[n][m];
                }
                else
                {
                    item[jsondata[0][m]] = "";
                }
            }

            obj[jsondata[n][0]] = item;
        }
        return obj;
    }
})


var GameDataDic = cc.Class.extend({

    // 数据字典集合
    dataDic:null,
    // 数据集合个数
    num:null,

    ctor: function ()
    {
        this.dataDic = new Object();
        this.num = 0;
    },

    addData:function(key, obj)
    {
        this.dataDic[key] = obj;
        this.num++;
    },

    deleteData:function(key)
    {
        var obj = this.dataDic[key];
        this.dataDic[key] = null;
        delete this.dataDic[key];
        this.num--;
    },

    getDataByKey:function(key)
    {
        return this.dataDic[key];
    },

    getDataNum:function()
    {
        return this.num;
    }
})
