/**
 * Created by Administrator on 2016/4/27.
 */
var TileMap = cc.Class.extend({

    // 坐标偏移值
    offsetX:null,
    offsetY:null,
    // 格子大小
    gridWidth:null,
    gridHeight:null,
    // 格子的边界
    gridMaxX:null,
    gridMaxY:null,
    // 是否初始化
    isInit: null,
    // 格子数组
    gridArr:null,
    // 格子的默认值
    defaultGridValue:null,

    initialize: function (data)
    {
        if (this.isInit == true)
        {
            return;
        }
        this.isInit = true;

        this.offsetX = data.offsetX;
        this.offsetY = data.offsetY;
        this.gridWidth = data.gridWidth;
        this.gridHeight = data.gridHeight;
        this.gridMaxX = data.gridMaxX;
        this.gridMaxY = data.gridMaxY;
        this.defaultGridValue = data.defaultGridValue;

        this.gridArr = [];
        for(var n = 0; n < this.gridMaxX; n++)
        {
            var mapArry = [];
            for(var m = 0; m < this.gridMaxY; m++)
            {
                mapArry.push(this.defaultGridValue);
            }
            this.gridArr.push(mapArry);
        }
    },

    //重新设置tilemap属性
    setTileMapAttribute:function(data)
    {
        this.offsetX = data.offsetX;
        this.offsetY = data.offsetY;
        this.gridWidth = data.gridWidth;
        this.gridHeight = data.gridHeight;
        this.gridMaxX = data.gridMaxX;
        this.gridMaxY = data.gridMaxY;
        this.defaultGridValue = data.defaultGridValue;

        this.gridArr = [];
        for(var n = 0; n < this.gridMaxX; n++)
        {
            var mapArry = [];
            for(var m = 0; m < this.gridMaxY; m++)
            {
                mapArry.push(this.defaultGridValue);
            }
            this.gridArr.push(mapArry);
        }
    },

    // 重置格子
    clearGridInfo:function(x, y)
    {
        this.setGridInfo(x, y, this.defaultGridValue);
    },

    // 设置格子内容
    setGridInfo:function(x, y, obj)
    {
        if(obj != null)
        {
            // 消除了的 是不能添加进去的
            if(obj.isDespose)
            {
                printLog("消除掉的元素");
                return;
            }
            obj.gridX = x;
            obj.gridY = y;
        }
        this.gridArr[x][y] = obj;
    },

    // 根据格子位置返回格子内容
    getGridByGridPoint:function(gridX, gridY)
    {
        if(gridX < 0 || gridY < 0 || gridX >= this.gridMaxX || gridY >= this.gridMaxY)
        {
            return null;
        }

        var selectGrid = this.gridArr[gridX][gridY];
        return selectGrid;
    },

    // 根据场景位置返回格子内容
    getGridByScenePoint:function(sceneX, sceneY)
    {
        var gridPoint = this.getScenePointByGridPoint(sceneX, sceneY);
        return this.getGridByGridPoint(gridPoint.x, gridPoint.y);
    },

    // 根据场景的点返回格子的点
    getScenePointByGridPoint:function(sceneX, sceneY)
    {
        var startX = Math.floor((sceneX - this.offsetX) / this.gridWidth);
        var startY = this.gridMaxY - 1 - Math.floor((sceneY - this.offsetY) / this.gridHeight);
        return cc.p(startX, startY);
    },

    // 根据格子的点返回场景的点
    getGridPointByScenePoint:function(gridX, gridY)
    {
        var point = cc.p(gridX * this.gridWidth + this.gridWidth / 2, (this.gridMaxY - 1 - gridY) * this.gridHeight + this.gridHeight/2);
        point.x = point.x + this.offsetX;
        point.y = point.y + this.offsetY;
        return point;
    },

    // 给格子的场景坐标排版
    settingGridByScene:function(grids)
    {
        for(var n = 0; n < grids.length; n++)
        {
            var gridPoint = this.getScenePointByGridPoint(grids[n].x, grids[n].y);
            var scenePoint = this.getGridPointByScenePoint(gridPoint.x, gridPoint.y);
            grids[n].x = scenePoint.x;
            grids[n].y = scenePoint.y;
        }
    },

    // 根据格子的A*坐标排版
    settingGridByAStar:function(grids)
    {
        for(var n = 0; n < this.gridArr.length; n++)
        {
            for(var m = 0; m < this.gridArr[n].length; m++)
            {
                var gird = this.gridArr[n][m];
                if(gird != null)
                {
                    var scenePoint = this.getGridPointByScenePoint(n, m);
                    gird.x = scenePoint.x;
                    gird.y = scenePoint.y;
                }
            }
        }
    },

    // 根据格子给出周围的数组坐标
    getRectGridsPointByFour:function(gridX, gridY)
    {
        var arr = [];
        if(gridX + 1 < this.gridMaxX)
        {
            arr.push(cc.p(gridX + 1, gridY));
        }
        if(gridX - 1 >= 0)
        {
            arr.push(cc.p(gridX - 1, gridY));
        }
        if(gridY - 1 >= 0)
        {
            arr.push(cc.p(gridX, gridY - 1));
        }
        if(gridY + 1 < this.gridMaxY)
        {
            arr.push(cc.p(gridX, gridY + 1));
        }
        return arr;
    }
})