/**
 * Created by Administrator on 2016/5/12.
 */

var monsterTypeID = 1000;
var towerTypeID = 1001;
var decorateTypeID = 1002;

var GameElementManage = cc.Class.extend({

    // 是否初始化
    isInit: null,
    // 游戏中元素集合
    gameElementDic:null,
    // 游戏元件增长编号
    elementID:null,
    // 测试需要碰撞的元素集合
    checkSillElementDic:null,
    // 网格数据
    gameGridDataDic:null,

    ctor: function ()
    {
        this.isInit = false;
        this.checkSillElementDic = new Object();
        this.gameGridDataDic = new Object();
    },

    // 清空网格数据字典
    cleanGameGridDic:function()
    {
        for(var key in this.gameGridDataDic)
        {
            this.gameGridDataDic[key].reset();
        }
    },

    // 设置新的网格
    setGameGridDic:function(typeID, data)
    {
        var gameGridData = new GameGridData();
        gameGridData.initialize(data);
        this.gameGridDataDic[typeID] = gameGridData;
    },

    // 重置网格
    resetGameGridDic:function(typeID)
    {
        this.gameGridDataDic[typeID].reset();
    },

    // 获取网格
    getGameGridDic:function(typeID)
    {
        return this.gameGridDataDic[typeID];
    },

    setCheckSkillElementDic:function(typeID)
    {
        this.checkSillElementDic[typeID] = typeID;
    },

    initialize: function()
    {
        if (this.isInit == true)
        {
            return;
        }

        this.gameElementDic = new Object();
    },

    // 增加字典
    addGameElementDic:function(key)
    {
        if(this.gameElementDic[key] == null)
        {
            this.gameElementDic[key] = new GameDataDic();
        }
    },

    // 清空所有字典
    cleanGameElementDic:function()
    {
        this.elementID = 1000;
        for(var key in this.gameElementDic)
        {
            this.gameElementDic[key] = new GameDataDic();
        }
    },

    // 获取字典的整个数据
    getGameElementDic:function(key)
    {
        return this.gameElementDic[key].dataDic;
    },

    // 添加对象
    addElement:function(id, typeID, element)
    {
        this.gameElementDic[typeID].addData(id, element);
    },

    // 获取对象
    getElement:function(id, typeID)
    {
        if(this.gameElementDic[typeID] == null)
        {
            return null;
        }
        return this.gameElementDic[typeID].getDataByKey(id);
    },

    // 移除对象
    deleteElement:function(id, typeID)
    {
        this.gameElementDic[typeID].deleteData(id);
    },

    // 获取元件编号
    getElementID:function()
    {
        this.elementID++;
        return this.elementID;
    },

    // 获取场景上是否拥有某种类型
    getElementTypeNum:function(key)
    {
        return this.gameElementDic[key].getDataNum();
    }
})

// 获取元素信息
var engineGetElement = function(animalID, animaType)
{
    return engine.gameElementManage.getElement(animalID, animaType);
}