/**
 * Created by Administrator on 2016/3/10.
 */
var GameSound = cc.Class.extend({

    // 是否初始化
    isInit:null,
    // 音量
    soundVolume:null,
    // 是否关闭声音
    stopSound:null,
    // 当前播放的背景音乐
    playMusicUrl:null,
    // 上次播放时间
    lastTimeDic:null,

    // 设置默认值
    ctor: function ()
    {
        this.isInit = false;
        this.soundVolume = 100;
        this.stopSound = false;
        this.playMusicUrl = "";
        this.lastTimeDic = new Object();
    },

    // 初始化
    initialize: function ()
    {
        if (this.isInit == true)
        {
            return;
        }

        this.isInit = true;
    },

    // 停止音乐
    stopMusic:function()
    {
        this.stopSound = true;
        cc.audioEngine.setMusicVolume(0);
        cc.audioEngine.setEffectsVolume(0);
    },

    // 打开音乐
    openMusic:function()
    {
        this.stopSound = false;
        cc.audioEngine.setMusicVolume(this.soundVolume);
        cc.audioEngine.setEffectsVolume(this.soundVolume);
    },

    // 改变声音方式
    changeMusicState:function()
    {
        if(this.stopSound == true)
        {
            this.openMusic();
        }
        else
        {
            this.stopMusic();
        }
    },

    // 设置音量大小
    setSoundVolume:function(value)
    {
        this.soundVolume = value;
        if(this.stopSound == false)
        {
            cc.audioEngine.setMusicVolume(value);
            cc.audioEngine.setEffectsVolume(this.soundVolume);
        }
    },

    playEffect:function(url)
    {
        var nowTime = engineGameRunTime();
        if(this.lastTimeDic[url] != null)
        {
            if(nowTime - playEffectMinTime <= this.lastTimeDic[url])
            {
                return;
            }
        }

        this.lastTimeDic[url] = nowTime;
        var url = getUrlByVersion(url);
        cc.audioEngine.playEffect(url);
    },

    playMusic:function(url, loop)
    {
        var url = getUrlByVersion(url);
        if(loop == null)
        {
            loop = true;
        }

        if(this.playMusicUrl != url)
        {
            this.playMusicUrl = url;
            cc.audioEngine.playMusic(url, loop);
        }
    }
})
