var GameTime = cc.Class.extend({

    // 当前时间
    nowDate:null,
    // 是否初始化
    isInit: null,
    // 游戏运行时间 减去了站厅 或 其他停止时间
    gameRunTime:null,
    // 游戏是否暂停
    isPause:null,
    // 上次心跳时间
    lastTime:null,

    ctor: function()
    {
        this.isInit = false;
        this.isPause = false;
        this.gameRunTime = 0;
        var date = new Date();
        this.nowDate = date.getTime();
        this.lastTime = this.nowDate;
    },

    initialize:function()
    {
        if (this.isInit == true)
        {
            return;
        }

        this.isInit = true;
    },

    updateTime:function(data)
    {
        //var date = new Date();
        //this.nowDate = date.getTime();
        if(this.isPause == false)
        {
            //if(this.nowDate - this.lastTime > 0)
            //{
                this.gameRunTime = this.gameRunTime + data * 1000;
            //}
        }
        //this.lastTime = this.nowDate;
    }
});

// 获取游戏时间
var engineGameRunTime = function()
{
    return engine.gameTime.gameRunTime;
}

// 游戏暂停
var engineGamePause = function(value)
{
    engine.gameTime.isPause = value;
}

var gameUpdateType = 2;
var sceneUpdateType = 1;

var GameUpdate = cc.Class.extend({

    // 游戏心跳更新数组,不会被转场时候删除掉
    gameUpdateList:null,
    // 游戏场景心跳更新数组,会被转场释放掉
    sceneUpdateList:null,
    // 是否初始化
    isInit: null,

    ctor: function()
    {
        this.gameUpdateList = [];
        this.sceneUpdateList = [];
        this.isInit = false;
    },

    initialize:function()
    {
        if (this.isInit == true)
        {
            return;
        }
        this.isInit = true;
    },

    update:function()
    {
        for(var n = this.gameUpdateList.length - 1; n >= 0; n--)
        {
            this.gameUpdateList[n].update();
            if(this.gameUpdateList[n].isEnd == true)
            {
                this.gameUpdateList.splice(n, 1);
            }
        }

        for(var m = this.sceneUpdateList.length - 1; m >= 0; m--)
        {
            this.sceneUpdateList[m].update();
            if(this.sceneUpdateList[m].isEnd == true)
            {
                this.sceneUpdateList.splice(m, 1);
            }
        }
    },

    // 添加心跳
    addUpdate:function(obj, type)
    {
        if(type == null)
        {
            type = sceneUpdateType;
        }
        switch(type)
        {
            case gameUpdateType:
                this.gameUpdateList.push(obj);
                break;
            case sceneUpdateType:
                this.sceneUpdateList.push(obj);
                break;
        }
    },

    // 根据类型移除心跳
    cleanUpdate:function(updateType)
    {
        switch(updateType)
        {
            case gameUpdateType:
                this.sceneUpdateList = [];
                break;
            case sceneUpdateType:
                this.gameUpdateList = [];
                break;
        }
    }
})

var TimeOut = cc.Class.extend({

    // 结束时间
    endTime:null,
    // 是否初始化
    isInit: null,
    // 方法函数
    callFuntion:null,
    // 回调数据
    data:null,
    // 是否结束
    isEnd:null,

    ctor: function()
    {
        this.isInit = false;
        this.isEnd = false;
    },

    initialize:function(data)
    {
        if (this.isInit == true)
        {
            return;
        }

        this.isInit = true;
        this.endTime = data.endTime;
        this.callFuntion = data.callFuntion;
        this.endTime = data.endTime;
        this.data = data.data;
    },

    update:function()
    {
        if(this.isEnd == true)
        {
            return;
        }
        if(engineGameRunTime() - this.endTime >= 0)
        {
            this.callFuntion.call(this.data);
            this.isEnd = true;
        }
    }
})

// 方法 时间 参数  类型   1 转场 2永久
var engineSetTimeOut = function(fun, time, data, type)
{
    var timeOut = new TimeOut();
    var obj = new Object();
    obj.callFuntion = fun;
    obj.endTime = engineGameRunTime() + time * 1000;
    obj.data = data;
    timeOut.initialize(obj);
    engine.gameUpdate.addUpdate(timeOut, type);
}