/**
 * Created by Administrator on 2016/3/17.
 */

var author = "yx";
var printLog = function (log)
{
    cc.log(author + ":" + log)
}

//根据两点坐标算角度
var getAngle = function(beginPoint, finishPoint)
{
    var angle = 0;
    var valueX = finishPoint.x - beginPoint.x;
    var valueY = finishPoint.y - beginPoint.y;
    angle = Math.atan2(valueY, valueX);
    //弧度换算成角度（1弧度=180/π度）
    angle = angle * (180 / Math.PI);
    if(angle < 0)
    {
        angle += 360;
    }
    angle = angle % 360;
    return angle;
}

//根据两点坐标算弧度
var getRadian = function(beginPoint, finishPoint)
{
    var angle = 0;
    var valueX = finishPoint.x - beginPoint.x;
    var valueY = finishPoint.y - beginPoint.y;
    angle = Math.atan2(valueX, valueY);
    if(angle < 0)
    {
        angle += 2 * Math.PI;
    }
    return angle;
}

//根据起始点坐标,角度,距离,求终点
var beginPointTodistance = function(beginPoint,angleValue,distance)
{
    //angleValue = 90 - angleValue;
    angleValue *= (Math.PI/180.0);
    return cc.pAdd(beginPoint, cc.p(distance*Math.cos(angleValue), distance*Math.sin(angleValue)));
}

// 深拷贝对象
var cloneObject = function(obj)
{
    var copyObj = new Object();
    for(var key in obj)
    {
        copyObj[key] = obj[key];
    }
    return copyObj;
}

//左对齐
var leftSetting = "leftSetting";
//右对齐
var rightSetting = "rightSetting";
//居中对齐
var centerSetting = "centerSetting";
//垂直
var verticalCenterSetting = "verticalCenterSetting";

var gameSpSettingFun = function(data)
{
    // 精灵对象数组
    var spArr = data.spArr;
    // 精灵对象宽度或高度
    var spWidth = data.spWidth;
    //排序中心点
    var p = data.p;
    //排序类型
    var settingType = data.settingType;

    switch(settingType)
    {
        case leftSetting:
            for(var i = 0; i < spArr.length; i++)
            {
                spArr[i].x = p.x  - spWidth * i;
                spArr[i].y = p.y;
            }
            break;
        case rightSetting:
            for(var i = 0; i < spArr.length; i++)
            {
                spArr[i].x = p.x  + spWidth * i;
                spArr[i].y = p.y;
            }
            break;
        case centerSetting:
            if(spArr.length % 2 > 0)
            {
                var middlevalue = Math.floor(spArr.length / 2) + 1;
                for(var i = 0; i < spArr.length; i++)
                {
                    spArr[i].y = p.y;
                    if(i <= middlevalue - 1)
                    {
                        spArr[i].x = p.x - i * spWidth;
                    }
                    else
                    {
                        spArr[i].x = p.x + (i-Math.floor(spArr.length / 2)) * spWidth;
                    }
                }
            }
            else
            {
                for(var i = 0; i < spArr.length; i++)
                {
                    spArr[i].y = p.y;
                    if(i < Math.floor(spArr.length/2))
                    {
                        spArr[i].x = p.x - (Math.floor(spArr.length/2) - i) * spWidth + spArr[i].anchorX * spWidth;
                    }
                    else
                    {
                        spArr[i].x = p.x + (i - Math.floor(spArr.length/2)) * spWidth + spArr[i].anchorX * spWidth;
                    }
                }
            }
            break;
        case verticalCenterSetting :
            if(spArr.length % 2 > 0)
            {
                var middlevalue = Math.floor(spArr.length / 2);//中间
                for(var i = 0; i < spArr.length; i++)
                {
                    spArr[i].x = p.x;
                    if(i <= middlevalue)
                    {
                        spArr[i].y = p.y + (middlevalue - i) * spWidth;
                    }
                    else
                    {
                        spArr[i].y = p.y - (i - middlevalue) * spWidth;
                    }
                }
            }
            else
            {
               for(var i = 0; i < spArr.length; i++)
               {
                   spArr[i].x = p.x;
                   if(i < Math.floor(spArr.length/2))
                   {
                       spArr[i].y = p.y + (Math.floor(spArr.length/2) - i) * spWidth - 0.5 * spWidth;
                   }
                   else
                   {
                       spArr[i].y = p.y - (i - Math.floor(spArr.length/2)) * spWidth - 0.5 * spWidth;
                   }
               }
            }
            break;
    }
}

var getDirByPointFour = function(begin, end)
{
    var dir = 4;
    if(begin.x < end.x)
    {
        dir = 6;
    }
    if(begin.x > end.x)
    {
        dir = 4;
    }
    if(begin.x == end.x)
    {
        if(begin.y < end.y)
        {
            dir = 6;
        }
        else
        {
            dir = 4;
        }
    }
    return dir;
}


