var BackgroundLayer = cc.Layer.extend({
    id: 0,
    data: 0,
    mainUI: null,
    startPos: null,
    bgSize: null,
    ctor: function(id){
        this._super();
        this.id = id || 2001;

        this.data = Utils.getDataByID(GameSceneConfig, this.id);
        this.bgSize = cc.size(this.data.size.w, this.data.size.h);
    },
    onEnter: function(){
        this._super();
        this.initUI();
        this.startPos = this.getPosition();
        this.registerEvent();
        this.playBgMusic();
    },
    onExit: function(){
        this._super();
        Event.remove(EVENT_ID.MUSIC, this);
    },
    registerEvent: function(){
        Event.register(EVENT_ID.MUSIC, function(){
            this.playBgMusic();
        }, this);
    },
    playBgMusic: function(){
        if(this.id === 2001){
            SoundMgr.playMusic(soundRes.sound_city, true);
        }
    },
    initUI: function(){
        var name = Utils.getBgJsonByID(this.id);
        this.mainUI = ParseFlashJson.loadJson(name,this.data);
        this.mainUI.attr({x: 0,y:0});
        // this.mainUI.setScale(0.5);
        this.addChild(this.mainUI, GAME_TAG.BG, GAME_TAG.BG);
    },
    getData: function(){
        return this.data;
    },
    getBgSize: function (){
        // var size = cc.size(this.data.size.w, this.data.size.h);
        return this.bgSize;
    }
});