var HomeScene = GameScene.extend({
    ctor: function(){
        this._super();
        SoundMgr.isOpen = gameUserData.sound === 1;
    },
    onEnter: function(){
        this._super();

        if(!Global.isPure){
            initGameSDK();
        }

        this.preloadMusic();
        var layer = new GameFightLayer();
        this.addChild(layer);
        this.initialize();
    },
    // 先播放一遍音乐
    preloadMusic: function(){
        cc.audioEngine.setEffectsVolume(0);
        SoundMgr.playEffect(soundRes.sound_eat_gold);
        SoundMgr.playEffect(soundRes.sound_hit_hook);
        SoundMgr.playEffect(soundRes.sound_jump);
        SoundMgr.playEffect(soundRes.sound_hit_wall);
        SoundMgr.playEffect(soundRes.sound_hook_up);
        this.scheduleOnce(function(){
            cc.audioEngine.setEffectsVolume(100);
        },0.1);

    },
    loadResource: function(){
        cc.spriteFrameCache.addSpriteFrames(res.res_game_role_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_obstacle_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_gold_plist);

        cc.spriteFrameCache.addSpriteFrames(res.res_game_common_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_task_plist);

        for(var i = 1; i <= 32; i += 1){
            cc.spriteFrameCache.addSpriteFrames("res/csi/map_bg"+ i + ".plist");
        }
   /*     cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg1_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg2_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg3_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg4_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg5_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg6_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg7_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg8_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg9_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg10_plist);
        cc.spriteFrameCache.addSpriteFrames(res.res_game_map_bg11_plist);*/
    },
    initializeGame: function(){
        this._super();
        this.sceneName = "HomeScene";
        this.addChild(new HomeLayer());
    }
});
