var SDK_TAG = {
    BUY_BTN_TAG: 1000
};
// sdk 商店界面
var SDKLayer = cc.Layer.extend({
    mainUI: null,
    ctor: function(){
        this._super();
    },
    onEnter: function(){
        this._super();
        this.initUI();
        this.initListener();

        Event.register("refreshGold", function(data){
            this.mainUI.goldText.setString(gameUserData.gold);
        }, this);
    },
    onExit: function(){
        this._super();
        Event.remove("refreshGold", this);
    },
    initUI: function(){
        this.mainUI = loadCSS(gameRes.res_game_sdk_json);
        this.addChild(this.mainUI);

        this.mainUI.goldText.setString(gameUserData.gold);
        this.mainUI.goldText.ignoreContentAdaptWithSize(true);
    },
    // 增加事件监听
    initListener:function(){
        for(var i = 1; i <= 4; i += 1){
            var obj = this.mainUI["btn" + i];
            obj.setTag(SDK_TAG.BUY_BTN_TAG + i);
            obj.text.setString(gSdkData.itemPrices[i - 1]);

            this.mainUI["num" + i].setString(gSdkData.itemGoldNum[i - 1]);
            this.mainUI["num" + i].ignoreContentAdaptWithSize(true);

            engine.gameEvent.createMouseUp(obj, this.onBuy.bind(this), buttonScalingType);
        }
        engine.gameEvent.createMouseUp(this.mainUI.btnClose, this.onClose.bind(this), buttonScalingType);
    },
    onBuy: function(touch, event){
        var obj = event.getCurrentTarget();
        var id = obj.getTag() - SDK_TAG.BUY_BTN_TAG + 1;
        SDKControl.payItemWithMoney(id, this);
    },
    onClose: function(){
        this.removeFromParent();
    }
});
var SDK_TYPE = {
    OCC: 1, // 激活模式(ok按钮，close 按钮， cgv 按钮)
    WAIT: 2, // 等待模式 (没有按钮)
    O: 3, // 确认模式 (ok按钮)
    OC: 4 // 确认取消模式 （ok按钮， close按钮）
};
 // sdk 询问弹框
var SDK_Dialog = cc.Layer.extend({
    type: 0, // 取值为 SDK_TYPE
    id: 0, // 购买id 1 激活 ，2-5购买，6 礼包
    des: null, // 描述
    dialog_type: 0, // 1 区分激活和购买描述
    mainUI: null,
    ctor: function(type, des, id){
        this._super();
        this.type = type || 0;
        this.des = des || "";
        this.id = id || 0;
    },
    onEnter: function(){
        this._super();
        this.initUI();
        Event.register("refreshSDKDialog", function(data){
            if(!data){
                this.onClose();
            } else {
                this.des = data;
                this.initDialog(SDK_TYPE.O);
            }
        }, this);
    },
    onExit: function(){
        this._super();
        Event.remove("refreshSDKDialog", this);
    },
    initUI: function(){
        // createMaskLayer(this);
        this.mainUI = loadCSS(res.res_sdk_dialog_json);
        this.addChild(this.mainUI);

        // this.mainUI.attr({x: 360, y: 640});
        this.initDialog(this.type);
    },
    // 根据类型 生成弹框
    initDialog: function(type){
        // type = type || this.type;
        this.type = type;
        this.mainUI.OCC.setVisible(false);
        this.mainUI.WAIT.setVisible(false);
        this.mainUI.O.setVisible(false);
        this.mainUI.OC.setVisible(false);
        switch(type){
            case SDK_TYPE.OCC:  // 激活和购买描述
                this.mainUI.OCC.setVisible(true);
                this.mainUI.OCC.des.setString(this.des);
                this.showGiveReward();
                engine.gameEvent.createMouseUp(this.mainUI.OCC.btnOk, this.onActivate.bind(this), buttonScalingType);
                engine.gameEvent.createMouseUp(this.mainUI.OCC.btnClose, this.onClose.bind(this), buttonScalingType);
                engine.gameEvent.createMouseUp(this.mainUI.OCC.cgv, this.onCGV.bind(this), buttonScalingType);
                break;
            case SDK_TYPE.WAIT: // 等待
                this.mainUI.WAIT.setVisible(true);
                this.mainUI.WAIT.des.setString(this.des);
                break;
            case SDK_TYPE.O:  // 支付结果
                this.mainUI.O.setVisible(true);
                this.mainUI.O.des.setString(this.des);
                engine.gameEvent.createMouseUp(this.mainUI.O.btnOk, this.onOK.bind(this), buttonScalingType);
                break;
            case SDK_TYPE.OC:  // 支付再次确认
                this.mainUI.OC.setVisible(true);
                this.mainUI.OC.des.setString(this.des);
                engine.gameEvent.createMouseUp(this.mainUI.OC.btnOk, this.onOK.bind(this), buttonScalingType);
                engine.gameEvent.createMouseUp(this.mainUI.OC.btnClose, this.onClose.bind(this), buttonScalingType);
                break;
            default:
                cc.log("out of ID !!!");
                break;
        }
        this.type = type;
    },
    // 显示激活赠送物品 或者 购买进入
    showGiveReward: function(){
        // this.mainUI.OCC.reward.setVisible(false);
        // this.mainUI.OCC.cgv.x = 0;
        /*if(!gSdkData.isShowShop || this.dialog_type === 1){
            // this.mainUI.OCC.des.y = 30;
            this.mainUI.OCC.cgv.x = 0;
        }*/
        this.showCGV();
    },
    // 显示 cgv
    showCGV:function(){
        showSMSBtn();
        if(Global.isPure || !gSdkData.isSMSbtn){
            this.mainUI.OCC.saisircod.setVisible(false);
            return;
        }
        engine.gameEvent.createMouseUp(this.mainUI.OCC.saisircod, this.onSend, buttonScalingType);
    },
    // 发送短信
    onSend: function(){
        sendSMSFun();
    },
    // 确定激活
    onActivate: function(){
        cc.log("on activate !!! id = " + this.id );
        this.payMoney(this.id);
    },
    // 支付描述流程
    payMoneyDes: function(id){
        if(gSdkData.isFreeSilentArr[id - 1]){
            paymentOK(id);
        }
    },
    // 支付流程
    payMoney: function(id){
        if(gSdkData.isFreeSilentArr[id - 1]){
            paymentOK(id);
        } else if(gSdkData.isDoubleConfirm[id - 1]) {
            this.des = gSdkData.itemConfirmDes[id - 1];
            this.initDialog(SDK_TYPE.OC);
        } else {
            this.des = gSdkData.waitDes[id - 1];
            this.initDialog(SDK_TYPE.WAIT);
            payItem(id);
        }
    },
    // 关闭
    onClose: function(){
        cc.log("on close !!!");
        this.removeFromParent();
    },
    // 确定购买
    onOK: function(){
        cc.log("on ok !!!");
        if(this.id === 1 && gameUserData.isLockState === 1){
            // transitions(LevelScene);
            this.removeFromParent();
            return;
        } else if(this.id === 6 && gameUserData.giftIsGetted === 1){
            // gameUserData.giftIsGetted = 1;
            Event.emit("runAction");
            this.removeFromParent();
            return;
        }
        this.dealOK();
    },
    // 处理确认事件
    dealOK: function(){
        cc.log("dealOk() type = " + this.type);
        switch(this.type){
            case SDK_TYPE.O:
                this.onClose();
                break;
            case SDK_TYPE.OC:
                this.des = gSdkData.waitDes[this.id - 1];
                this.initDialog(SDK_TYPE.WAIT);
                payItem(this.id);
                break;
            default:
                cc.log("out of ID !!!");
                break;
        }
    },
    // cgv 事件
    onCGV: function(){
        cc.log("on CGV !!!");
        onSendCGV();
    }

});