var gSdkData = gSdkData || {}; //sdk数据
gSdkData.isFreeArr = [false, false, false, false, false, false]; // 是否走免费流程
gSdkData.isFreeSilentArr = [false, false, false, false, false, false]; // 是否不走支付流程
gSdkData.isDoubleConfirm = [false, false, false, false, false, false]; // 是否显示二次确认弹框
gSdkData.itemConfirmDes = ["", "", "", "","", ""]; // 再次支付确认描述
gSdkData.itemWaitDes = ["", "", "", "","", ""]; // 支付等待描述描述
gSdkData.activePrice = 0; // 游戏激活价格
gSdkData.unlockLevel = 0; // 解锁关卡
gSdkData.itemPrices = [0,0,0,0,0]; // 商品价格
gSdkData.itemGoldNum = [0,0,0,0,0];// 商品金币数量
gSdkData.buySuccessDes = [];  // 购买成功提示
gSdkData.waitDes = []; //  购买等待提示
gSdkData.unLockDes = ""; // 激活描述
gSdkData.failDes1 = ""; // 购买失败描述
gSdkData.failDes2 = ""; // 购买失败描述
gSdkData.failDes3 = ""; // 购买失败描述
gSdkData.failDes4 = ""; // 购买失败描述
gSdkData.failDes5 = ""; // 购买失败描述
gSdkData.msgErrDes = ""; // 默认失败描述
gSdkData.cgvTxt = ""; //cgv 内容
gSdkData.buttonConfirmTxt = ""; // 确认按钮文本
gSdkData.buttionBackTxt = ""; // 返回按钮文本
gSdkData.isShowShop = 0; // 0不显示 1 显示
gSdkData.isSMSbtn = false; // 是否显示cgv 
gSdkData.isFirstEnter = false; // 是否第一次进入

// 初始化sdk
function initGameSDK(){
    if(!cc.sys.isNative || gSdkData.isFirstEnter) return;
    initGame();
    gSdkData.isFirstEnter = true;
}

function  initSDKInfo(){
    if(!cc.sys.isNative)  return;

    isItemFreeInit();   // 免费流程初始化
    isItemFreeSilentInit(); // 不走支付流程初始化
    isDoubleConfirmInit(); // 是否显示二次弹框
    getItemConfirmDes();    // 获取再次字符缺描述
    getActivePrice();  // 获取激活价格
    getUnlockLevel();  // 获取解锁关卡
    getItemPrice();    // 获取商品价格(包括购买价格，获得的金币数量)
    getBuyDes();       //  获取购买商品描述
    getFailedDes();    //  获取购买失败的描述
    getShowShopState(); // 获取是否显示商店
    showSMSBtn();       // 是否显示  cgv
}
/**
 * 重启
 */
function  initGame(){
    if(!cc.sys.isNative)  return;
    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "initGame", "()V");
}

// 免费流程初始化
function isItemFreeInit(){ 
    if(!cc.sys.isNative) return;
    for(var i = 0; i < gSdkData.isFreeArr.length; i += 1){
        gSdkData.isFreeArr[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemIsFree","(I)Z",(i+1));
        cc.log("gSdkData.isFreeArr"+i+":"+gSdkData.isFreeArr[i]);
    }
}
// 不走支付模式初始化
function isItemFreeSilentInit(){
    if(!cc.sys.isNative) return;
    for(var i = 0; i < gSdkData.isFreeSilentArr.length; i += 1){
        gSdkData.isFreeSilentArr[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemIsFreeSilent","(I)Z",(i+1));
        cc.log("gSdkData.isFreeSilentArr"+i+":"+gSdkData.isFreeSilentArr[i]);
    }
}
// 是否显示二次确认弹框
function isDoubleConfirmInit(){
    if(!cc.sys.isNative) return;
    for(var i = 0; i < gSdkData.isDoubleConfirm.length; i += 1){
        gSdkData.isDoubleConfirm[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getIsDoubleConfim","(I)Z",(i+1));
        cc.log("gSdkData.isDoubleConfirm"+i+":"+gSdkData.isDoubleConfirm[i]);
    }
}
// 获取再次支付确认描述
function getItemConfirmDes(){
    if(!cc.sys.isNative) return;
    for(var i = 0; i < gSdkData.itemConfirmDes.length;i++){
        // 再次确认描述
        gSdkData.itemConfirmDes[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getConfirmDescription","(I)Ljava/lang/String;",(i+1));
       // 等待支付描述
        gSdkData.itemWaitDes[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemDescription","(I)Ljava/lang/String;",(i+1));
        cc.log("itemConfirmDes"+i+":"+gSdkData.itemConfirmDes[i]);
    }
}
//获取激活价格
function getActivePrice(){
    gSdkData.activePrice = getPriceByID(1);
}
//获取解锁关卡
function getUnlockLevel(){
    gSdkData.unlockLevel = getGoldNumByID(1);
    if(gSdkData.unlockLevel <= 0){
        gameUserData.isLockState = 1;
        saveUserData();
    }
}
// 货物商品价格
function getItemPrice(){
    var length = gSdkData.itemPrices.length;
    for(var i = 0; i < length; i += 1){
        gSdkData.itemPrices[i] = getPriceByID(i + 2);
        gSdkData.itemGoldNum[i] = getGoldNumByID(i + 2);
    }
}
// 获取价格 1 代表激活价格，2-5是商品价格 6 礼包价格
function getPriceByID(id){
   var price = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemPrice","(I)Ljava/lang/String;", id);
   cc.log("id = " + id + "  price = " + price);
   return price;
}
// 获取金币数量 1 代表激活关卡 2-5商品价格 6 礼包
function getGoldNumByID(id){
    var num = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemNum","(I)I", id);
    cc.log("id = " + id + "  num = " + num);
    return num;
}
// 购买描述
function getBuyDes(){
    for(var i = 0; i < gSdkData.isFreeArr.length; i += 1){
        // 获取购买成功描述
        gSdkData.buySuccessDes[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuySuccessDes","(I)Ljava/lang/String;", (i+1));
        // 获取等待描述
        gSdkData.waitDes[i] = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuyInprogressDes","(I)Ljava/lang/String;", (i+1)); 
    }
    // cgv 文本
    gSdkData.cgvTxt = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getCGVTxt","()Ljava/lang/String;");
    // 确定文本
    gSdkData.buttonConfirmTxt = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getButtonConfirm","()Ljava/lang/String;");
    // 返回文本
    gSdkData.buttionBackTxt = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getButtonBack","()Ljava/lang/String;");
}
// 购买失败描述
function getFailedDes(){
    gSdkData.unLockDes = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getItemDescription","(I)Ljava/lang/String;",1);
    gSdkData.failDes1 = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuyFailDesOne","()Ljava/lang/String;");
    gSdkData.failDes2 = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuyFailDesTwo","()Ljava/lang/String;");
    gSdkData.failDes3 = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuyFailDesThree","()Ljava/lang/String;");
    gSdkData.failDes4 = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getBuyFailDesFour","()Ljava/lang/String;");
    gSdkData.failDes5 = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getPaymentCancelled","()Ljava/lang/String;");
    gSdkData.msgErrDes = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getMsgErrDes","()Ljava/lang/String;");
}
// 是否显示商店
function getShowShopState(){
    gSdkData.isShowShop = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","getIsShowShop","()I");
    cc.log(" gSdkData.isShowShop:"+ gSdkData.isShowShop)
}
// 是否显示按钮
function showSMSBtn(){
    if(!cc.sys.isNative)  return;
    var resultNum=jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","isShowEnterCodeButton","()I");
    switch (resultNum){
        case 1:
            gSdkData.isSMSbtn = true;
            break;
        default:
            gSdkData.isSMSbtn = false;
            break;
    }
}
// 发送短信
function sendSMSFun(){
    if(!cc.sys.isNative) return;
    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","startCodeUI","()V");
}
// 支付成功
function paymentOK(goodsID, result){
    cc.log("paymentOK");
    switch(goodsID){
        case 1:  // 激活
            gameUserData.isLockState = 1;
            gameUserData.gold += 500;
            Event.emit("showAddButton");
            break;
        case 2:
            gameUserData.gold += gSdkData.itemGoldNum[0];
            break;
        case 3:
            gameUserData.gold += gSdkData.itemGoldNum[1];
            break;
        case 4:
            gameUserData.gold += gSdkData.itemGoldNum[2];
            break;
        case 5:
            gameUserData.gold += gSdkData.itemGoldNum[3];
            break;
        case 6: // 礼包
            for(var i =1;i<4;i++){
                gameUserData[Global.giftInfo[i-1].itemname] += Global.giftInfo[i-1].itemnum;
            }
            gameUserData.giftIsGetted = 1;
            // Event.emit("runAction");
            break;
        default:
            cc.log("is out of function paymentOK()!!!");
            break;
    }

    Event.emit("refreshGold");
    cc.log("payment ok str = " + gSdkData.buySuccessDes[goodsID - 1]);
    Event.emit("refreshSDKDialog", gSdkData.buySuccessDes[goodsID - 1]);

    saveUserData();
}
// 支付失败
function paymentFailed(goodsId,result){
    cc.log("paymentFailed");
    var str = "";
    switch(result){
        case -3:
            str = gSdkData.failDes1;
            break;
        case -4:
            str = gSdkData.failDes2;
            break;
        case -5:
            str = gSdkData.failDes3;
            break;
        case -6:
            str = gSdkData.failDes4;
            break;
        case -9:
            str = gSdkData.failDes5;
            break;
        default:
            str = gSdkData.msgErrDes;
            break;
    }
    cc.log("pay failed  str = " + str);
    Event.emit("refreshSDKDialog", str);
}
// 支付购买
function payItem(id){
    if(!cc.sys.isNative) return;
    cc.log("payItem"+id);
    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","payItem","(I)V", id);
}
// cgv按钮事件
function onSendCGV(){
    if(!cc.sys.isNative) return;
    jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity","startTCUI","()V")
}